<?php

namespace Picea\Ui\Method;

use Picea\Extension\Extension,
    Picea\Extension\ExtensionTrait;

use Picea\Compiler\Context;

use Psr\Http\Message\ServerRequestInterface;

class Form implements Extension {
    use ExtensionTrait;

    public array $tokens;

    public string $token;

    public FormContext $formContext;
    
    public ServerRequestInterface $request;
    
    public function __construct(ServerRequestInterface $request, Context $context) {
        $this->request = $request;
        $this->register($context);
    }

    public function parse(/*\Picae\Compiler\Context*/ &$context, ?string $arguments, string $token) : string { }

    public function register(Context $context) : void
    {
        $context->pushFunction("form", [ $this, 'formClass' ]);
    }

    public function form_csrf(string $field, string $value) {
        $values = $this->session("View.form.csrf.$field") ?: [];

        # keeps 20 (from config) latest CSRF key for this form into session,
        # allowing more than one tab opened and preventing information loss
        if ( count($values) >= 20 ) {
            #array_shift($values);
        }

        $values[] = $value;

        $this->session("View.form.csrf.$field", $values);

        return $value;
    }

    public function formClass(FormInterface $form, ? FormContext $formContext = null) : FormHandler
    {
        return new FormHandler($this->request, $form, $formContext ?? $this->formContext ?? null);
    }
}
